// Some useful functions for CGI processing...

#include "cgi.h"
extern "C" {
#include <stdlib.h>
#include <iostream.h>
#include <stdio.h>
}

CGI::CGI(Method m)
{
	char *query=0;
	string parameters;
	
	if(m!=POST)
		query=getenv("QUERY_STRING");
	if(query && !strlen(query)) // Work around some broken getenv() implementations
		query=0;
	
	if(m==AUTO && query && strlen(query))	m=GET;
	else if(m==AUTO)			m=POST;
	if(m==POST) {
		char buf[1024];
		while(fgets(buf, 1023, stdin)) {
			parameters+=buf;
		}
	} else {
		if(query)
			parameters=query;
	}
	parse(parameters);
}
CGI::~CGI()
{
}

string const CGI::getpar(string const par)
{
	return parameter[par];
}

// Make sure we don't compile on crappy OSes... ;)
// This piece of code should be everywhere...
#if defined(WIN32) || defined(WIN16) || defined(WINDOWS) || defined(windows) \
    || defined(win32) || defined(win16) || defined(CYGWIN) || defined(cygwin) \
    || defined(__windows__) || defined(MSVC) || defined(__MSVC__)
#define i if
#define for if
#define while if
#endif
	
void CGI::parse(string parameters)
{
	int previous=0, pos;
	string current;
	string key,value;
	parameter.empty();
	vars.empty();
	while((pos=parameters.find('&', previous))>=0) {
		current = parameters.substr(previous, pos-previous);
		key=current.substr(0, current.find('='));
		value=translate(current.substr(current.find('=')+1));
		parameter[key]=value;
		vars.insert(vars.end(), key);
		previous=pos+1;
	}
	current = parameters.substr(previous);
	key=current.substr(0, current.find('='));
	value=translate(current.substr(current.find('=')+1));
	value=translate(current.substr(current.find('=')+1));
	parameter[key]=value;
}

string CGI::translate(string s)
{
	while((signed int)s.find('+')>=0) {
		s[s.find('+')]=' ';
	}
	while((signed int)s.find('%')>=0) {
		char hex[2];
		hex[0]=s[s.find('%')+1];
		hex[1]=s[s.find('%')+2];
		hex[2]=0;
		char a=(char) strtoul(hex, NULL, 16);	
		s=s.replace(s.find('%'), 3, a);
	}
	return s;
}

