#include "mail.h"

mail::mail(string subj, string msg, stringlist rcpt, string frm, bool now, string srv)
{
	subject=subj;
	message=msg;
	from=frm;
	recipients=rcpt;
	server=srv;
	if(now)
		send();
}

mail::mail(string subj, string msg, string rcpt, string frm, bool now, string srv)
{
	subject=subj;
	message=msg;
	from=frm;
	recipients.empty();
	recipients.insert(recipients.begin(), rcpt);
	server=srv;
	if(now)
		send();
}

mail::~mail()
{
}

void mail::to(string addr)
{
	recipients.insert(recipients.end(),addr);
}

int mail::send()
{
	int err;
	Socket s(server, 25);
	if(s.reply()!=220)
		err++;
	if(s.reply("HELO " + server)!=250)
		err++;
	if(s.reply("MAIL FROM:<" + from + ">")!=250)
		err++;
	for(stringlist_it a=recipients.begin(); a!=recipients.end(); a++)
		if(s.reply("RCPT TO:<" + *a + ">")!=250)
			err++;
	if(s.reply("DATA")!=354)
		err++;
	s << "To: ";
	for(stringlist_it a=recipients.begin(); a!=recipients.end(); a++) {
		if(a!=recipients.begin())
			s << ", ";
		s << *a;
	}
	s << "\n";
	s << "From: " + from + "\n";
	s << "Subject: " + subject + "\n";
	s << "\n";
	s << message;
	s << "\n";
	if(s.reply(".")!=250)
		err++;
	if(s.reply("QUIT")!=221)
		err++;
	return err;
}
